/*
 * gbiff2 program
 * Copyright (C) 2000-2003 Nicolas Rougier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <glade/glade.h>
#include <glade/glade-build.h>
#include "gbiff2.h"

#ifndef __SUPPORT_H
#define __SUPPORT_H

#define WIDGET(w)		__widget(biff,w)

#ifdef ENABLE_NLS
#include<libintl.h>
#ifndef USE_GNOME
#define _(String) dgettext(GETTEXT_PACKAGE,String)
#endif
#ifdef gettext_noop
#define N_(String) gettext_noop(String)
#else
#define N_(String) (String)
#endif
#else /* NLS is disabled */
#define _(String) (String)
#define N_(String) (String)
#define textdomain(String) (String)
#define gettext(String) (String)
#define dgettext(Domain,String) (String)
#define dcgettext(Domain,String,Type) (String)
#define bindtextdomain(Domain,Directory) (Domain)
#endif


/* 
 * Bitmask returned by XParseGeometry().  Each bit tells if the corresponding
 * value (x, y, width, height) was found in the parsed string.
 */
#define NoValue         0x0000
#define XValue          0x0001
#define YValue          0x0002
#define WidthValue      0x0004
#define HeightValue     0x0008
#define AllValues       0x000F
#define XNegative       0x0010
#define YNegative       0x0020


/* Automatic signal connection for libglade, using gmodule */
void MyGladeXMLConnectFunc (const gchar *handler_name,
                            GObject *object,
                            const gchar *signal_name,
                            const gchar *signal_data,
                            GObject *connect_object,
                            gboolean after,
                            gpointer user_data);

/* Get the specified widget from the XML tree */
GtkWidget *__widget (Biff *biff, gchar *wname);

/* Conversions */
gchar *filename_from_utf8 (const gchar *string);
gchar *filename_to_utf8 (gchar *string);
gchar *locale_from_utf8 (const gchar *string);
gchar *locale_to_utf8 (gchar *string);

/* Pango font loading */
PangoFontDescription *getfont (gchar *fontname);

/* Parse a geometry strign and move window accordingly */
int gtk_XParseGeometry (const char *string,
			       int *x, int *y,
			       unsigned int *width, unsigned int *height);
gboolean my_gtk_window_parse_geometry (GtkWindow *window, const gchar *geometry);

#endif /* __SUPPORT_H */
